<template>
    <v-container>
        <v-row dense class="pa-0">
            <v-spacer></v-spacer>
            <v-col class="flex-shrink-1 flex-grow-0">
                <v-switch
                    class="mt-0"
                    v-model="enabled"
                    :loading="loading"
                    :label="$t('enabled')"
                    :true-value="true"
                    :false-value="false"
                    hide-details
                    dense
                ></v-switch>
            </v-col>
        </v-row>

        <validation-observer ref="observer" slim>
            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('name') }}</div>
                    <validation-provider v-slot="{ errors }" name="name" rules="required">
                        <v-text-field
                            v-model="name"
                            :loading="loading"
                            :error-messages="errors"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('code') }}</div>
                    <validation-provider v-slot="{ errors }" name="code" rules="required">
                        <v-text-field
                            v-model="code"
                            :loading="loading"
                            :error-messages="errors"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('plan') }}</div>
                    <validation-provider v-slot="{ errors }" name="plan_ids" rules="required">
                        <v-plan-select
                            v-model="plan_ids"
                            :errors="errors"
                            :placeholder="$t('plan_select')"
                            outlined
                        >
                        </v-plan-select>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('duration') }}</div>
                    <validation-provider v-slot="{ errors }" name="duration" rules="required">
                        <v-select
                            v-model="duration"
                            :loading="loading"
                            :items="durations"
                            :menu-props="{ bottom: true, offsetY: true }"
                            :error-messages="errors"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-select>
                    </validation-provider>
                </v-col>

                <v-col v-if="repeating">
                    <div class="field-label">{{ $t('num_of_month') }}</div>
                    <validation-provider v-slot="{ errors }" name="num_of_month" rules="required|min_value:1">
                        <v-text-field
                            v-model="numOfMonth"
                            :error-messages="errors"
                            :suffix="$t('month')"
                            type="number"
                            hide-details="auto"
                            dense
                            outlined
                        ></v-text-field>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <div class="field-label">{{ $t('discount_type') }}</div>
                    <validation-provider v-slot="{ errors }" name="discount_type" rules="required">
                        <v-radio-group
                            v-model="discountType"
                            :loading="loading"
                            :error-messages="errors"
                            hide-details="auto"
                        >
                            <v-radio
                                value="amount"
                                :label="$t('amount_discount')"
                            ></v-radio>
                            <v-radio
                                value="percentage"
                                :label="$t('percent_discount')"
                            ></v-radio>
                        </v-radio-group>
                    </validation-provider>
                </v-col>
            </v-row>

            <v-row v-if="discountType">
                <v-col>
                    <div class="field-label">{{ $t('discount') }}</div>
                    <v-expand-transition>
                        <validation-provider v-slot="{ errors }" name="discount" rules="required|decimal">
                            <v-text-field
                                v-model="discount"
                                :loading="loading"
                                :error-messages="errors"
                                hide-details="auto"
                                :suffix="percentageDiscount ? '%' : 'MYR'"
                                dense
                                outlined
                            ></v-text-field>
                        </validation-provider>
                    </v-expand-transition>
                </v-col>
            </v-row>

            <v-row>
                <v-col>
                    <v-btn
                        class="text-capitalize px-0"
                        @click="advance = !advance"
                        text
                    >
                        <span class="field-label mb-0">
                            {{ $t('adv_settings') }}
                            <v-icon right>mdi-chevron-double-down</v-icon>
                        </span>
                    </v-btn>

                    <v-expand-transition>
                        <v-card
                            v-show="advance"
                            :loading="loading"
                            flat
                        >
                            <div class="field-label pt-2">{{ $t('redemption_limit') }}</div>
                            <v-checkbox
                                v-model="limitByDate"
                                :loading="loading"
                                :label="$t('limit_date')"
                                hide-details="auto"
                                dense
                            ></v-checkbox>
                            <div
                                v-if="limitByDate"
                                class="d-flex py-2"
                            >
                                <validation-provider v-slot="{ errors }" name="date" rules="required|future">
                                    <v-menu
                                        ref="datePicker"
                                        :close-on-content-click="false"
                                        :nudge-right="40"
                                        transition="scale-transition"
                                        offset-y
                                        min-width="290px"
                                    >
                                        <template v-slot:activator="{ on, attrs }">
                                            <v-text-field
                                                v-model="redeemByDate"
                                                :loading="loading"
                                                :error-messages="errors"
                                                prepend-icon="mdi-calendar"
                                                hide-details="auto"
                                                v-bind="attrs"
                                                v-on="on"
                                                readonly
                                                dense
                                                outlined
                                            ></v-text-field>
                                        </template>
                                        <v-date-picker
                                            v-model="redeemByDate"
                                            @input="$refs.datePicker.save(redeemByDate)"
                                        ></v-date-picker>
                                    </v-menu>
                                </validation-provider>
                                <validation-provider v-slot="{ errors }" name="time" rules="required">
                                    <v-menu
                                        ref="timePicker"
                                        :close-on-content-click="false"
                                        :nudge-right="40"
                                        :return-value.sync="redeemByTime"
                                        transition="scale-transition"
                                        offset-y
                                        max-width="290px"
                                    >
                                        <template v-slot:activator="{ on, attrs }">
                                            <v-text-field
                                                class="pl-2"
                                                v-model="redeemByTime"
                                                :loading="loading"
                                                :error-messages="errors"
                                                prepend-icon="mdi-clock-time-four-outline"
                                                hide-details="auto"
                                                v-bind="attrs"
                                                v-on="on"
                                                readonly
                                                dense
                                                outlined
                                            ></v-text-field>
                                        </template>
                                        <v-time-picker
                                            v-model="redeemByTime"
                                            @click:minute="$refs.timePicker.save(redeemByTime)"
                                            full-width
                                            format="ampm"
                                            ampm-in-title
                                        ></v-time-picker>
                                    </v-menu>
                                </validation-provider>
                            </div>
                            <v-checkbox
                                v-model="limitByNumber"
                                :loading="loading"
                                :label="$t('limit_number')"
                                hide-details="auto"
                                dense
                            ></v-checkbox>
                            <v-text-field
                                class="py-2"
                                v-if="limitByNumber"
                                v-model="numberLimit"
                                :loading="loading"
                                :hint="$t('limit_number_desc')"
                                :suffix="$t('times')"
                                hide-details="auto"
                                dense
                                outlined
                            >
                            </v-text-field>
                        </v-card>
                    </v-expand-transition>
                </v-col>
            </v-row>

            <v-row justify="center">
                <v-col cols="4">
                    <v-btn
                        :loading="loading"
                        @click="validate"
                        color="primary"
                        block
                    >
                        {{ $t('create') }}
                    </v-btn>
                </v-col>
            </v-row>
        </validation-observer>
    </v-container>
</template>

<script>
    import moment from 'moment';
    import { ValidationObserver, ValidationProvider } from "vee-validate";
    import { mapMutations } from "vuex";
    import VPlanSelect from "../VPlanSelect";

    export default {
        name: 'CouponCreateForm',
        props: {
            loading: {
                type: Boolean,
                default: false
            }
        },
        components: {
            ValidationObserver,
            ValidationProvider,
            VPlanSelect
        },
        data: () => ({
            name: null,
            code: null,
            plan_ids:[],
            discount: null,
            duration: null,
            discountType: null,
            advance: false,
            numOfMonth: 0,
            redeemByDate: null,
            redeemByTime: null,
            limitByDate: false,
            limitByNumber: false,
            numberLimit: 0,
            enabled: true
        }),
        computed: {
            durations() {
                return [
                    { text: this.$t('once'), value: 'once' },
                    { text: this.$t('repeating'), value: 'repeating' },
                    { text: this.$t('forever'), value: 'forever' },
                ]
            },
            repeating() {
                return this.duration === 'repeating'
            },
            percentageDiscount() {
                return this.discountType === 'percentage'
            },
            redeemBy() {
                return `${this.redeemByDate} ${this.redeemByTime}:00`
            },
            dateRules() {
                return 'date_format:dd/MM/yyyy|after:afterTarget'
            },
            model() {
                const object = {
                    name: this.name,
                    code: this.code,
                    duration: this.duration,
                    enabled: this.enabled,
                    plan_ids: this.plan_ids
                }

                if(this.percentageDiscount) {
                    object.percent_off = this.discount;
                }
                else {
                    object.amount_off = this.discount;
                    object.currency = 'myr';
                }

                if(this.repeating) {
                    object.duration_in_months = this.numOfMonth;
                }
                if(this.limitByNumber) {
                    object.max_redemptions = this.numberLimit;
                }
                if(this.limitByDate) {
                    object.redeem_by = this.redeemBy;
                }

                return object;
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'error'
            ]),
            async validate() {
                const valid = await this.$refs.observer.validate()

                if(valid) {
                    this.$emit('validated', this.model)
                }
            },
        }
    }
</script>

<style scoped>

</style>
